diff a/test/hotspot/jtreg/compiler/valhalla/inlinetypes/GetfieldChains.jcod b/test/hotspot/jtreg/compiler/valhalla/inlinetypes/GetfieldChains.jcod
--- /dev/null
+++ b/test/hotspot/jtreg/compiler/valhalla/inlinetypes/GetfieldChains.jcod
@@ -0,0 +1,702 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+// Generated from the following class files with PointN.x removed and RectangleP.p1 made private
+// java org.openjdk.asmtools.Main jdec NamedRectangleN.class NamedRectangleP.class PointN.class RectangleN.class RectangleP.class
+
+/*
+package compiler.valhalla.inlinetypes;
+
+import jdk.internal.vm.annotation.ImplicitlyConstructible;
+import jdk.internal.vm.annotation.LooselyConsistentValue;
+import jdk.internal.vm.annotation.NullRestricted;
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+value class PointN {
+    int x; // Removed
+    int y;
+
+    PointN(int i, int j) {
+        x = i;
+        y = j;
+    }
+}
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+value class RectangleN {
+    @NullRestricted
+    PointN p1 = new PointN(4, 7);
+}
+
+class NamedRectangleN {
+    @NullRestricted
+    RectangleN rect = new RectangleN();
+    String name = "";
+
+    static int getP1X(NamedRectangleN nr) {
+        return nr.rect.p1.x;
+    }
+}
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+value class RectangleP {
+    @NullRestricted
+    PointN p1 = new PointN(4, 7); // Made private
+}
+
+class NamedRectangleP {
+    @NullRestricted
+    RectangleP rect = new RectangleP();
+    String name = "";
+
+    static int getP1Y(NamedRectangleP nr) {
+        return nr.rect.p1.y;
+    }
+}
+*/
+
+class compiler/valhalla/inlinetypes/NamedRectangleN {
+  0xCAFEBABE;
+  65535; // minor version
+  67; // version
+  [] { // Constant Pool
+    ; // first element is empty
+    Method #2 #3; // #1
+    class #4; // #2
+    NameAndType #5 #6; // #3
+    Utf8 "java/lang/Object"; // #4
+    Utf8 "<init>"; // #5
+    Utf8 "()V"; // #6
+    class #8; // #7
+    Utf8 "compiler/valhalla/inlinetypes/RectangleN"; // #8
+    Method #7 #3; // #9
+    Field #11 #12; // #10
+    class #13; // #11
+    NameAndType #14 #15; // #12
+    Utf8 "compiler/valhalla/inlinetypes/NamedRectangleN"; // #13
+    Utf8 "rect"; // #14
+    Utf8 "Lcompiler/valhalla/inlinetypes/RectangleN;"; // #15
+    String #17; // #16
+    Utf8 ""; // #17
+    Field #11 #19; // #18
+    NameAndType #20 #21; // #19
+    Utf8 "name"; // #20
+    Utf8 "Ljava/lang/String;"; // #21
+    Field #7 #23; // #22
+    NameAndType #24 #25; // #23
+    Utf8 "p1"; // #24
+    Utf8 "Lcompiler/valhalla/inlinetypes/PointN;"; // #25
+    Field #27 #28; // #26
+    class #29; // #27
+    NameAndType #30 #31; // #28
+    Utf8 "compiler/valhalla/inlinetypes/PointN"; // #29
+    Utf8 "x"; // #30
+    Utf8 "I"; // #31
+    Utf8 "RuntimeVisibleAnnotations"; // #32
+    Utf8 "Ljdk/internal/vm/annotation/NullRestricted;"; // #33
+    Utf8 "Code"; // #34
+    Utf8 "LineNumberTable"; // #35
+    Utf8 "getP1X"; // #36
+    Utf8 "(Lcompiler/valhalla/inlinetypes/NamedRectangleN;)I"; // #37
+    Utf8 "SourceFile"; // #38
+    Utf8 "Point.java"; // #39
+    Utf8 "Preload"; // #40
+  } // Constant Pool
+
+  0x0020; // access
+  #11;// this_cpx
+  #2;// super_cpx
+
+  [] { // Interfaces
+  } // Interfaces
+
+  [] { // Fields
+    {  // field
+      0x0000; // access
+      #14; // name_index
+      #15; // descriptor_index
+      [] { // Attributes
+        Attr(#32) { // RuntimeVisibleAnnotations
+          [] { // annotations
+            {  //  annotation
+              #33;
+              [] { // element_value_pairs
+              }  //  element_value_pairs
+            }  //  annotation
+          }
+        } // end RuntimeVisibleAnnotations
+      } // Attributes
+    }
+    ;
+    {  // field
+      0x0000; // access
+      #20; // name_index
+      #21; // descriptor_index
+      [] { // Attributes
+      } // Attributes
+    }
+  } // Fields
+
+  [] { // Methods
+    {  // method
+      0x0000; // access
+      #5; // name_index
+      #6; // descriptor_index
+      [] { // Attributes
+        Attr(#34) { // Code
+          3; // max_stack
+          1; // max_locals
+          Bytes[]{
+            0x2AB700012ABB0007;
+            0x59B70009B5000A2A;
+            0x1210B50012B1;
+          }
+          [] { // Traps
+          } // end Traps
+          [] { // Attributes
+            Attr(#35) { // LineNumberTable
+              [] { // line_number_table
+                0  26;
+                4  27;
+                15  29;
+              }
+            } // end LineNumberTable
+          } // Attributes
+        } // end Code
+      } // Attributes
+    }
+    ;
+    {  // method
+      0x0008; // access
+      #36; // name_index
+      #37; // descriptor_index
+      [] { // Attributes
+        Attr(#34) { // Code
+          1; // max_stack
+          1; // max_locals
+          Bytes[]{
+            0x2AB4000AB40016B4;
+            0x001AAC;
+          }
+          [] { // Traps
+          } // end Traps
+          [] { // Attributes
+            Attr(#35) { // LineNumberTable
+              [] { // line_number_table
+                0  32;
+              }
+            } // end LineNumberTable
+          } // Attributes
+        } // end Code
+      } // Attributes
+    }
+  } // Methods
+
+  [] { // Attributes
+    Attr(#38) { // SourceFile
+      #39;
+    } // end SourceFile
+    ;
+    Attr(#40) { // Preload
+      0x00010007;
+    } // end Preload
+  } // Attributes
+} // end class compiler/valhalla/inlinetypes/NamedRectangleN
+class compiler/valhalla/inlinetypes/NamedRectangleP {
+  0xCAFEBABE;
+  65535; // minor version
+  67; // version
+  [] { // Constant Pool
+    ; // first element is empty
+    Method #2 #3; // #1
+    class #4; // #2
+    NameAndType #5 #6; // #3
+    Utf8 "java/lang/Object"; // #4
+    Utf8 "<init>"; // #5
+    Utf8 "()V"; // #6
+    class #8; // #7
+    Utf8 "compiler/valhalla/inlinetypes/RectangleP"; // #8
+    Method #7 #3; // #9
+    Field #11 #12; // #10
+    class #13; // #11
+    NameAndType #14 #15; // #12
+    Utf8 "compiler/valhalla/inlinetypes/NamedRectangleP"; // #13
+    Utf8 "rect"; // #14
+    Utf8 "Lcompiler/valhalla/inlinetypes/RectangleP;"; // #15
+    String #17; // #16
+    Utf8 ""; // #17
+    Field #11 #19; // #18
+    NameAndType #20 #21; // #19
+    Utf8 "name"; // #20
+    Utf8 "Ljava/lang/String;"; // #21
+    Field #7 #23; // #22
+    NameAndType #24 #25; // #23
+    Utf8 "p1"; // #24
+    Utf8 "Lcompiler/valhalla/inlinetypes/PointN;"; // #25
+    Field #27 #28; // #26
+    class #29; // #27
+    NameAndType #30 #31; // #28
+    Utf8 "compiler/valhalla/inlinetypes/PointN"; // #29
+    Utf8 "y"; // #30
+    Utf8 "I"; // #31
+    Utf8 "RuntimeVisibleAnnotations"; // #32
+    Utf8 "Ljdk/internal/vm/annotation/NullRestricted;"; // #33
+    Utf8 "Code"; // #34
+    Utf8 "LineNumberTable"; // #35
+    Utf8 "getP1Y"; // #36
+    Utf8 "(Lcompiler/valhalla/inlinetypes/NamedRectangleP;)I"; // #37
+    Utf8 "SourceFile"; // #38
+    Utf8 "Point.java"; // #39
+    Utf8 "Preload"; // #40
+  } // Constant Pool
+
+  0x0020; // access
+  #11;// this_cpx
+  #2;// super_cpx
+
+  [] { // Interfaces
+  } // Interfaces
+
+  [] { // Fields
+    {  // field
+      0x0000; // access
+      #14; // name_index
+      #15; // descriptor_index
+      [] { // Attributes
+        Attr(#32) { // RuntimeVisibleAnnotations
+          [] { // annotations
+            {  //  annotation
+              #33;
+              [] { // element_value_pairs
+              }  //  element_value_pairs
+            }  //  annotation
+          }
+        } // end RuntimeVisibleAnnotations
+      } // Attributes
+    }
+    ;
+    {  // field
+      0x0000; // access
+      #20; // name_index
+      #21; // descriptor_index
+      [] { // Attributes
+      } // Attributes
+    }
+  } // Fields
+
+  [] { // Methods
+    {  // method
+      0x0000; // access
+      #5; // name_index
+      #6; // descriptor_index
+      [] { // Attributes
+        Attr(#34) { // Code
+          3; // max_stack
+          1; // max_locals
+          Bytes[]{
+            0x2AB700012ABB0007;
+            0x59B70009B5000A2A;
+            0x1210B50012B1;
+          }
+          [] { // Traps
+          } // end Traps
+          [] { // Attributes
+            Attr(#35) { // LineNumberTable
+              [] { // line_number_table
+                0  43;
+                4  44;
+                15  46;
+              }
+            } // end LineNumberTable
+          } // Attributes
+        } // end Code
+      } // Attributes
+    }
+    ;
+    {  // method
+      0x0008; // access
+      #36; // name_index
+      #37; // descriptor_index
+      [] { // Attributes
+        Attr(#34) { // Code
+          1; // max_stack
+          1; // max_locals
+          Bytes[]{
+            0x2AB4000AB40016B4;
+            0x001AAC;
+          }
+          [] { // Traps
+          } // end Traps
+          [] { // Attributes
+            Attr(#35) { // LineNumberTable
+              [] { // line_number_table
+                0  49;
+              }
+            } // end LineNumberTable
+          } // Attributes
+        } // end Code
+      } // Attributes
+    }
+  } // Methods
+
+  [] { // Attributes
+    Attr(#38) { // SourceFile
+      #39;
+    } // end SourceFile
+    ;
+    Attr(#40) { // Preload
+      0x00010007;
+    } // end Preload
+  } // Attributes
+} // end class compiler/valhalla/inlinetypes/NamedRectangleP
+class compiler/valhalla/inlinetypes/PointN {
+  0xCAFEBABE;
+  65535; // minor version
+  67; // version
+  [] { // Constant Pool
+    ; // first element is empty
+    Field #2 #3; // #1
+    class #4; // #2
+    NameAndType #5 #6; // #3
+    Utf8 "compiler/valhalla/inlinetypes/PointN"; // #4
+    Utf8 "y"; // #5
+    Utf8 "I"; // #6
+    Method #8 #9; // #7
+    class #10; // #8
+    NameAndType #11 #12; // #9
+    Utf8 "java/lang/Object"; // #10
+    Utf8 "<init>"; // #11
+    Utf8 "()V"; // #12
+    Utf8 "(II)V"; // #13
+    Utf8 "Code"; // #14
+    Utf8 "LineNumberTable"; // #15
+    Utf8 "SourceFile"; // #16
+    Utf8 "PointN.java"; // #17
+    Utf8 "RuntimeVisibleAnnotations"; // #18
+    Utf8 "Ljdk/internal/vm/annotation/ImplicitlyConstructible;"; // #19
+    Utf8 "Ljdk/internal/vm/annotation/LooselyConsistentValue;"; // #20
+  } // Constant Pool
+
+  0x0010; // access
+  #2;// this_cpx
+  #8;// super_cpx
+
+  [] { // Interfaces
+  } // Interfaces
+
+  [] { // Fields
+    {  // field
+      0x0810; // access
+      #5; // name_index
+      #6; // descriptor_index
+      [] { // Attributes
+      } // Attributes
+    }
+  } // Fields
+
+  [] { // Methods
+    {  // method
+      0x0000; // access
+      #11; // name_index
+      #13; // descriptor_index
+      [] { // Attributes
+        Attr(#14) { // Code
+          2; // max_stack
+          3; // max_locals
+          Bytes[]{
+            0x2A1CB500012AB700;
+            0x07B1;
+          }
+          [] { // Traps
+          } // end Traps
+          [] { // Attributes
+            Attr(#15) { // LineNumberTable
+              [] { // line_number_table
+                0  13;
+                5  12;
+                9  14;
+              }
+            } // end LineNumberTable
+          } // Attributes
+        } // end Code
+      } // Attributes
+    }
+  } // Methods
+
+  [] { // Attributes
+    Attr(#16) { // SourceFile
+      #17;
+    } // end SourceFile
+    ;
+    Attr(#18) { // RuntimeVisibleAnnotations
+      [] { // annotations
+        {  //  annotation
+          #19;
+          [] { // element_value_pairs
+          }  //  element_value_pairs
+        }  //  annotation
+        ;
+        {  //  annotation
+          #20;
+          [] { // element_value_pairs
+          }  //  element_value_pairs
+        }  //  annotation
+      }
+    } // end RuntimeVisibleAnnotations
+  } // Attributes
+} // end class compiler/valhalla/inlinetypes/PointN
+class compiler/valhalla/inlinetypes/RectangleN {
+  0xCAFEBABE;
+  65535; // minor version
+  67; // version
+  [] { // Constant Pool
+    ; // first element is empty
+    class #2; // #1
+    Utf8 "compiler/valhalla/inlinetypes/PointN"; // #2
+    Method #1 #4; // #3
+    NameAndType #5 #6; // #4
+    Utf8 "<init>"; // #5
+    Utf8 "(II)V"; // #6
+    Field #8 #9; // #7
+    class #10; // #8
+    NameAndType #11 #12; // #9
+    Utf8 "compiler/valhalla/inlinetypes/RectangleN"; // #10
+    Utf8 "p1"; // #11
+    Utf8 "Lcompiler/valhalla/inlinetypes/PointN;"; // #12
+    Method #14 #15; // #13
+    class #16; // #14
+    NameAndType #5 #17; // #15
+    Utf8 "java/lang/Object"; // #16
+    Utf8 "()V"; // #17
+    Utf8 "RuntimeVisibleAnnotations"; // #18
+    Utf8 "Ljdk/internal/vm/annotation/NullRestricted;"; // #19
+    Utf8 "Code"; // #20
+    Utf8 "LineNumberTable"; // #21
+    Utf8 "SourceFile"; // #22
+    Utf8 "Point.java"; // #23
+    Utf8 "Ljdk/internal/vm/annotation/ImplicitlyConstructible;"; // #24
+    Utf8 "Ljdk/internal/vm/annotation/LooselyConsistentValue;"; // #25
+    Utf8 "Preload"; // #26
+  } // Constant Pool
+
+  0x0010; // access
+  #8;// this_cpx
+  #14;// super_cpx
+
+  [] { // Interfaces
+  } // Interfaces
+
+  [] { // Fields
+    {  // field
+      0x0810; // access
+      #11; // name_index
+      #12; // descriptor_index
+      [] { // Attributes
+        Attr(#18) { // RuntimeVisibleAnnotations
+          [] { // annotations
+            {  //  annotation
+              #19;
+              [] { // element_value_pairs
+              }  //  element_value_pairs
+            }  //  annotation
+          }
+        } // end RuntimeVisibleAnnotations
+      } // Attributes
+    }
+  } // Fields
+
+  [] { // Methods
+    {  // method
+      0x0000; // access
+      #5; // name_index
+      #17; // descriptor_index
+      [] { // Attributes
+        Attr(#20) { // Code
+          5; // max_stack
+          1; // max_locals
+          Bytes[]{
+            0x2ABB000159071007;
+            0xB70003B500072AB7;
+            0x000DB1;
+          }
+          [] { // Traps
+          } // end Traps
+          [] { // Attributes
+            Attr(#21) { // LineNumberTable
+              [] { // line_number_table
+                0  22;
+                14  21;
+                18  22;
+              }
+            } // end LineNumberTable
+          } // Attributes
+        } // end Code
+      } // Attributes
+    }
+  } // Methods
+
+  [] { // Attributes
+    Attr(#22) { // SourceFile
+      #23;
+    } // end SourceFile
+    ;
+    Attr(#18) { // RuntimeVisibleAnnotations
+      [] { // annotations
+        {  //  annotation
+          #24;
+          [] { // element_value_pairs
+          }  //  element_value_pairs
+        }  //  annotation
+        ;
+        {  //  annotation
+          #25;
+          [] { // element_value_pairs
+          }  //  element_value_pairs
+        }  //  annotation
+      }
+    } // end RuntimeVisibleAnnotations
+    ;
+    Attr(#26) { // Preload
+      0x00010001;
+    } // end Preload
+  } // Attributes
+} // end class compiler/valhalla/inlinetypes/RectangleN
+class compiler/valhalla/inlinetypes/RectangleP {
+  0xCAFEBABE;
+  65535; // minor version
+  67; // version
+  [] { // Constant Pool
+    ; // first element is empty
+    class #2; // #1
+    Utf8 "compiler/valhalla/inlinetypes/PointN"; // #2
+    Method #1 #4; // #3
+    NameAndType #5 #6; // #4
+    Utf8 "<init>"; // #5
+    Utf8 "(II)V"; // #6
+    Field #8 #9; // #7
+    class #10; // #8
+    NameAndType #11 #12; // #9
+    Utf8 "compiler/valhalla/inlinetypes/RectangleP"; // #10
+    Utf8 "p1"; // #11
+    Utf8 "Lcompiler/valhalla/inlinetypes/PointN;"; // #12
+    Method #14 #15; // #13
+    class #16; // #14
+    NameAndType #5 #17; // #15
+    Utf8 "java/lang/Object"; // #16
+    Utf8 "()V"; // #17
+    Utf8 "RuntimeVisibleAnnotations"; // #18
+    Utf8 "Ljdk/internal/vm/annotation/NullRestricted;"; // #19
+    Utf8 "Code"; // #20
+    Utf8 "LineNumberTable"; // #21
+    Utf8 "SourceFile"; // #22
+    Utf8 "Point.java"; // #23
+    Utf8 "Ljdk/internal/vm/annotation/ImplicitlyConstructible;"; // #24
+    Utf8 "Ljdk/internal/vm/annotation/LooselyConsistentValue;"; // #25
+    Utf8 "Preload"; // #26
+  } // Constant Pool
+
+  0x0010; // access
+  #8;// this_cpx
+  #14;// super_cpx
+
+  [] { // Interfaces
+  } // Interfaces
+
+  [] { // Fields
+    {  // field
+      0x0812; // access
+      #11; // name_index
+      #12; // descriptor_index
+      [] { // Attributes
+        Attr(#18) { // RuntimeVisibleAnnotations
+          [] { // annotations
+            {  //  annotation
+              #19;
+              [] { // element_value_pairs
+              }  //  element_value_pairs
+            }  //  annotation
+          }
+        } // end RuntimeVisibleAnnotations
+      } // Attributes
+    }
+  } // Fields
+
+  [] { // Methods
+    {  // method
+      0x0000; // access
+      #5; // name_index
+      #17; // descriptor_index
+      [] { // Attributes
+        Attr(#20) { // Code
+          5; // max_stack
+          1; // max_locals
+          Bytes[]{
+            0x2ABB000159071007;
+            0xB70003B500072AB7;
+            0x000DB1;
+          }
+          [] { // Traps
+          } // end Traps
+          [] { // Attributes
+            Attr(#21) { // LineNumberTable
+              [] { // line_number_table
+                0  39;
+                14  38;
+                18  39;
+              }
+            } // end LineNumberTable
+          } // Attributes
+        } // end Code
+      } // Attributes
+    }
+  } // Methods
+
+  [] { // Attributes
+    Attr(#22) { // SourceFile
+      #23;
+    } // end SourceFile
+    ;
+    Attr(#18) { // RuntimeVisibleAnnotations
+      [] { // annotations
+        {  //  annotation
+          #24;
+          [] { // element_value_pairs
+          }  //  element_value_pairs
+        }  //  annotation
+        ;
+        {  //  annotation
+          #25;
+          [] { // element_value_pairs
+          }  //  element_value_pairs
+        }  //  annotation
+      }
+    } // end RuntimeVisibleAnnotations
+    ;
+    Attr(#26) { // Preload
+      0x00010001;
+    } // end Preload
+  } // Attributes
+} // end class compiler/valhalla/inlinetypes/RectangleP